%% The used method "Hengetime."
% Model the one-price system
% Model the two-price system
% Divide the volumes in the two markets

% Must draw a new volume with the statistichal properties of 1hour ahead
% forecast error. 

% Does not include trades in Elbas
samples=1000;
% Declerations
for l = 1:samples
nsamples = 8784;

%% Draws the balancing price 
% Assumed Normal Distribution false - vweibull
% Syntax: R = Normrnd(mu,sigma, m,n)
% mu = -0.1205 and sigma = 21.8524 found in R after removing extreme values
% ekstreme values are the values outside 3*sigma, 119 values removed

BalPriceRK = zeros(nsamples,1);

for i = 1:nsamples
    if (mod(i,24)>9 && mod(i,24)<23)
      %dag 
      BalPriceRK(i)= 0.3335*wblrnd(7.1757,1.0298) + 0.47814*wblrnd(9.0485,1.4831)*(-1);
      
    else
      %natt
      BalPriceRK(i)= 0.2856*wblrnd(7.1757,1.0298) + 0.4511*wblrnd(9.0485,1.4831)*(-1);
    end
 end
%% Draws the wind forecast error 
% - 24 hours ahead

WindError = normrnd(0.7335,11.4384,nsamples,1);

% 1 hour ahead
% Trial only, waiting for actual results from TrnderEnergi
% Reduced the sigma to 3

%WindError1 = normrnd(0,3,nsamples,1);

%% Calculates the costs in the two markets
% Costs one price system

%WindErrorOnePrice = WindError24-WindError1;
%WindErrorTwoPrice er den samme som WindError1

BalCostsOnePrice = 0.85*WindError.*BalPriceRK;% sett in beta, fjrn WindError1
SumOnePrice(l) = sum(BalCostsOnePrice);

%Costs two price system
Check = (BalPriceRK.*WindError <0);
BalCostsTwoPrice = 0.15*BalPriceRK.*WindError.*Check;%sett in alpha, fjern WindError1
SumTwoPrice(l) = sum(BalCostsTwoPrice);

% Sum of the two price systems
BalCosts = BalCostsTwoPrice + BalCostsOnePrice;
SumBalCosts(l) = sum(BalCosts);
end
%% Plots figures
figure
hist(SumOnePrice,100)
%title('Costs in oneprice system')

figure
hist(SumTwoPrice,100)
%title('Costs in twoprice system')

figure
hist(SumBalCosts,100)
%title('Total Costs')

[Results]=[1 2 3; mean(SumOnePrice) mean(SumTwoPrice) mean(SumBalCosts)]

SortertTotal=sort(SumBalCosts,'ascend');
figure
plot(SortertTotal)
%title('Sorted Balancing costs persistance model')


